<template>
    <div class="container">
      <div class="row mt-2">
        <div class="col-sm-3">
          <div class="input-group">
            <input class="form-control form-control-navbar" @keyup.enter="searchit"
            v-model="search" type="search" placeholder="search" aria-label="search">
            <button class="btn btn-primary" @click="searchit">
              <i class="fa fa-search inline"></i>
            </button>
          </div>
        </div>
      </div>

      <div class="row mt-2">
        <div class="col-12">
          <div class="card">
            <div class="card-header">
              <h3 class="card-title">List Event</h3>

              <div class="card-tools">
                  <button class="btn btn-success" @click="newModal">Add New <i class="fas fa-user-plus fa-fw"></i></button>
              </div>
            </div>
            <!-- /.card-header -->
            <div class="card-body table-responsive p-0">
              <table class="table table-hover">
                <thead>
                <tr>
                    <th>Poster</th>
                    <th>Nama Event</th>
                    <th>Kategori</th>
                    <th>Awal Pendaftaran</th>
                    <th>Akhir Pendaftaran</th>
                    <th>Tanggal Acara</th>
                    <th>Modify</th>
                </tr>
              </thead>
                <tbody>
                  <tr v-for="t_event in t_event.data" :key="t_event.id_event">
                    <td><img :src="getImgUrl(t_event.poster)" height="120px" width="100px"></td>
                    <td>{{t_event.nama_event}}</td>
                    <td>
                      <div v-if="t_event.type_event == '1'">Career Day</div>
                      <div v-else-if="t_event.type_event == '2'">Seminar</div>
                      <div v-else-if="t_event.type_event == '3'">Workshop</div>
                      <div v-else-if="t_event.type_event == '4'">Bootcamp</div>
                    </td>
                    <td>{{t_event.awal_pendaftaran}}</td>
                    <td>{{t_event.akhir_pendaftaran}}</td>
                    <td>{{t_event.tanggal_acara}}</td>
                    <td>
                      <a href="#" @click="editModal(t_event)">
                        <i class="fa fa-edit blue"></i>
                      </a>
                      /
                      <a href="#" @click="deleteEvent(t_event.id_event)">
                        <i class="fa fa-trash red"></i>
                      </a>
                    </td>
                  </tr>
              </tbody></table>
            </div>
            <!-- /.card-body -->
            <div class="card-footer">
                <pagination :data="t_event"
                @pagination-change-page="getResults"></pagination>
            </div>
          </div>
          <!-- /.card -->
        </div>
      </div>

      <!-- Modal -->
      <div class="modal fade" id="addNew" tabindex="-1" role="dialog" aria-labelledby="addNewLabel" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" v-show="!editmode" id="addNewLabel">Tambah Event</h5>
              <h5 class="modal-title" v-show="editmode" id="addNewLabel">Edit Event</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <form @submit.prevent="editmode ? updateEvent() : createEvent()" enctype="multipart/form-data">
              <div class="modal-body">
                <div class="form-group">
                  <label>Poster Event :</label><br>
                  <div class="row" v-show="editmode">
                    <div class="col">

                    </div>
                    <div>
                      <img :src="getImgUrl(form.poster)" width="200px" height="300px" alt="Responsive image" >
                    </div>
                    <div class="col">

                    </div>
                  </div>

                  <input type="file" @change="posterEvent" name="poster_event" class="form-input"><br>
                </div>
                <div class="form-group">
                  <label>Nama Event :</label>
                  <input v-model="form.nama_event" type="text" name="nama_event"
                    placeholder="Nama Event"
                    class="form-control" :class="{ 'is-invalid': form.errors.has('nama_event') }">
                  <has-error :form="form" field="nama_event"></has-error>
                </div>

                <div class="form-group">
                  <label>Kategori Event :</label>
                  <select v-model="form.type_event"  name="type_event"
                    class="form-control" :class="{ 'is-invalid': form.errors.has('type_event') }">
                    <option value="">Pilih Kategori Event</option>
                    <option value="1">Job Expo</option>
                    <option value="2">Seminar</option>
                    <option value="3">Workshop</option>
                    <option value="4">Bootcamp</option>
                  </select>
                  <has-error :form="form" field="type_event"></has-error>
                </div>

                <div class="form-row">
                  <div class="form-group col-md-6">
                    <label for="awal_pendaftaran">Awal Pendaftaran</label>
                    <input v-model="form.awal_pendaftaran" type="date" name="awal_pendaftaran"
                      class="form-control" :class="{ 'is-invalid': form.errors.has('awal_pendaftaran') }">
                    <has-error :form="form" field="awal_pendaftaran"></has-error>
                  </div>
                  <div class="form-group col-md-6">
                    <label for="akhir_pendaftaran">Akhir Pendaftaran</label>
                    <input v-model="form.akhir_pendaftaran" type="date" name="akhir_pendaftaran"
                      class="form-control" :class="{ 'is-invalid': form.errors.has('akhir_pendaftaran') }">
                    <has-error :form="form" field="akhir_pendaftaran"></has-error>
                  </div>
                </div>

                <div class="form-row">
                  <div class="form-group col-md-6">
                    <label for="tanggal_acara">Tanggal Acara</label>
                    <input v-model="form.tanggal_acara" type="date" name="tanggal_acara"
                      class="form-control" :class="{ 'is-invalid': form.errors.has('tanggal_acara') }">
                    <has-error :form="form" field="tanggal_acara"></has-error>
                  </div>
                </div>

                <div class="form-group">
                  <label for="headline">Headline</label>
                  <textarea v-model="form.headline"  name="headline"
                    placeholder="Masukkan Headline"
                    class="form-control" :class="{ 'is-invalid': form.errors.has('headline') }">
                  </textarea>
                  <has-error :form="form" field="headline"></has-error>
                </div>


              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-danger" data-dismiss="modal">Close</button>
                <button v-show="editmode" type="submit" class="btn btn-success">Update</button>
                <button v-show="!editmode" type="submit" class="btn btn-primary">Create</button>
              </div>
            </form>
        </div>
      </div>
      </div>


    </div>
</template>



<script>
import Form from 'vform'

    export default {
        data() {
          return {
              search: '',
              editmode: false,
              t_event : {},
              form: new Form({
                poster:'',
                id_event: '',
                nama_event: '',
                type_event: '',
                awal_pendaftaran: '',
                akhir_pendaftaran: '',
                tanggal_acara: '',
                headline: '',
              })
          }
        },
        methods: {
            posterEvent(e){
              //console.log('uploading');
              let file = e.target.files[0];
              //console.log(file);
              let reader = new FileReader();
              reader.onloadend = (file) =>{
                //console.log('RESULT', reader.result)
                this.form.poster = reader.result;
              }
              reader.readAsDataURL(file);

            },
            getImgUrl(t_event){
              if(t_event!=""){
                return "/img/event/"+t_event;
              } else
              return "/img/event/nothing.png";
            },
            searchit(){
              let query = this.search;
              axios.get('api/findEvent?q='+query)
              .then((data) => {
                this.t_event = data.data
              })
              .catch(() =>{

              })
            },
            getResults(page = 1) {
              axios.get('api/t_event?page=' + page)
                .then(response => {
                  this.t_event = response.data;
                });
            },
            updateEvent(){
              //  console.log('Editing data');
              this.form.put('api/t_event/'+this.form.id_event)
              .then(() => {
                swal(
                  'Updated!',
                  'Your file has been updated.',
                  'success'
                )
                $('#addNew').modal('hide')
                this.loadEvents();
              })
              .catch(() => {
                swal(
                  'Silahkan coba lagi.',
                  'error'
                )
              });
            },
            editModal(t_event){
              this.editmode = true;
              this.form.reset();
              $('#addNew').modal('show');
              this.form.fill(t_event);

            },
            newModal(){
              this.editmode = false;
              this.form.reset();
              $('#addNew').modal('show');
            },
            deleteEvent(id){
              swal({
                title: 'Are you sure?',
                text: "You won't be able to revert this!",
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!'
                }).then((result) => {

                  //send request to server
                  if (result.value){
                    this.form.delete('api/t_event/'+id).then(()=>{
                      swal(
                        'Deleted!',
                        'Your file has been deleted.',
                        'success'
                      )
                      this.loadEvents();
                    }).catch(()=>{
                      swal("Failed!","There was something wrong.","warning");
                    });
                  }

              })
            },
            loadEvents(){
                axios.get("api/t_event").then(({data}) => (this.t_event = data));
            },
            createEvent(){
                this.form.post('api/t_event')
                .then(()=>{
                  $('#addNew').modal('hide')

                  toast({
                    type: 'success',
                    title: 'Event created successfully'
                  })
                  this.loadEvents();
                })
            }
        },
        created() {
            this.loadEvents();
        }
    }
</script>
